=== debian/changelog ===
freeorion (0.5+git20230820-3) unstable; urgency=medium

  * Disable one static assertion test completely.

 -- Markus Koschany <apo@debian.org>  Tue, 22 Aug 2023 14:07:40 +0200

freeorion (0.5+git20230820-2) unstable; urgency=medium

  * Replace float equality tests with "close enough" tests to prevent a FTBFS
    on 32 bit architectures.

 -- Markus Koschany <apo@debian.org>  Mon, 21 Aug 2023 17:20:43 +0200

freeorion (0.5+git20230820-1) unstable; urgency=medium

  * New upstream snapshot 0.5+git20230820.
    - Fix FTBFS on 32 bit architectures.

 -- Markus Koschany <apo@debian.org>  Sun, 20 Aug 2023 18:27:46 +0200
